---
title: IDBIndex.getAllKeys()
slug: Web/API/IDBIndex/getAllKeys
tags:
  - API
  - IDBIndex
  - IndexedDB
  - Method
  - Reference
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>getAllKeys()</code></strong> method of the {{domxref("IDBIndex")}} interface instantly retrieves the primary keys of all objects inside the index, setting them as the <code>result</code> of the request object.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>allKeysRequest</em> = <em>IDBIndex</em>.getAllKeys();
var <em>allKeysRequest</em> = <em>IDBIndex</em>.getAllKeys(<em>query</em>);
var <em>allKeysRequest</em> = <em>IDBIndex</em>.getAllKeys(<em>query</em>, <em>count</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>query</em> {{optional_inline}}</dt>
 <dd>A key or an {{domxref("IDBKeyRange")}} identifying the keys to retrieve. If this value is null or missing, the browser will use an unbound key range.</dd>
 <dt><em>count</em> {{optional_inline}}</dt>
 <dd>The number records to return. If this value exceeds the number of records in the query, the browser will only retrieve the first item. If it is lower than <code>0</code> or greater than <code>2<sup>32</sup>-1</code> a {{jsxref("TypeError")}} exception will be thrown.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This {{domxref("IDBIndex")}}'s transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("IDBIndex")}} has been deleted or removed.<br>
     </td>
  </tr>
 </tbody>
</table>

<p>A {{jsxref("TypeError")}} exception is thrown if the <code>count</code> parameter is not between <code>0</code> and <code>2<sup>32</sup>-1</code> included.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var myIndex = objectStore.index('index');
var getAllKeysRequest = myIndex.getAllKeys();
getAllKeysRequest.onsuccess = function() {
  console.log(getAllKeysRequest.result);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB 2', '#dom-idbindex-getallkeys', 'getAll()')}}</td>
   <td>{{Spec2('IndexedDB 2')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbindex-getallkeys", "getAll()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.IDBIndex.getAllKeys")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
